/*
 * interpolation.c
 *
 *  Created on: 06.12.2017
 *      Author: Rafał
 */
#include "interpolation.h"

int32_t interpolate(int32_t x, int32_t N, int32_t* X, int32_t* Y){
	int32_t i;

	if( x <= X[0])
		return Y[0];
	if( x >= X[N-1])
		return Y[N-1];

	for(i = 1; x >= X[i]; i++);

	return (Y[i]-Y[i-1])*(x-X[i-1])/(X[i]-X[i-1])+Y[i-1];
}

#ifndef TINYTEST_NOTESTING

static int32_t N = 5;
static int32_t X[] = {4, 10, 30, 60, 100}; // sorted
static int32_t Y[] = {0, 100, 200, 300, 400};

int32_t test_interpolate(void)
{
    TINYTEST_EQUAL(Y[0], interpolate(X[0]-1, N, X, Y));
    TINYTEST_EQUAL(Y[N-1], interpolate(X[N-1]+1, N, X, Y));

    for(int32_t i=0; i < N; i++)
    	TINYTEST_EQUAL(Y[i], interpolate(X[i], N, X, Y));

    TINYTEST_EQUAL(50, interpolate(7, N, X, Y));
    TINYTEST_EQUAL(150, interpolate(20, N, X, Y));
    TINYTEST_EQUAL(250, interpolate(45, N, X, Y));
    TINYTEST_EQUAL(350, interpolate(80, N, X, Y));

    return 1;
}

TINYTEST_START_SUITE(Interpolate);
  TINYTEST_ADD_TEST(test_interpolate,NULL,NULL);
TINYTEST_END_SUITE();

#endif



